SystemOrganization addCategory: #'Arduino-Compiler-Uploading'!
SystemOrganization addCategory: #'Arduino-Compiler-Sketches'!
SystemOrganization addCategory: #'Arduino-Compiler-Translators'!
SystemOrganization addCategory: #'Arduino-Compiler-Output'!

CppKit subclass: #ArduinoCKit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Translators'!

!ArduinoCKit class methodsFor: 'factory' stamp: 'Richo 6/28/2011 12:32'!
programClass
	^ ArduinoCTranslatedProgram! !

CppTranslatedProgram subclass: #ArduinoCTranslatedProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Output'!

!ArduinoCTranslatedProgram methodsFor: 'compiling' stamp: 'Richo 11/23/2012 12:56'!
compile
	^ self compiler compile! !

!ArduinoCTranslatedProgram methodsFor: 'compiling' stamp: 'Richo 11/23/2012 12:20'!
compileFor: arduinoType
	^ self compiler compileFor: arduinoType! !

!ArduinoCTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 10/23/2012 13:43'!
compiler
	^ ArduinoCompiler on: self! !

!ArduinoCTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 6/28/2011 10:51'!
sourceFileName 
	^ programName, '.pde'! !

!ArduinoCTranslatedProgram methodsFor: 'compiling' stamp: 'Richo 11/23/2012 13:13'!
uploadOnPort: aByteString
	^ self compiler uploadOnPort: aByteString! !

!ArduinoCTranslatedProgram methodsFor: 'compiling' stamp: 'Richo 10/23/2012 13:43'!
uploadOnPort: aByteString arduinoType: anArduinoType 
	^ self compiler uploadOnPort: aByteString arduinoType: anArduinoType! !

!ArduinoCTranslatedProgram methodsFor: 'compiling' stamp: 'Richo 10/23/2012 13:43'!
verify
	^ self compiler verify! !

!ArduinoCTranslatedProgram methodsFor: 'compiling' stamp: 'Richo 11/23/2012 12:56'!
verifyFor: arduinoType
	^ self compiler verifyFor: arduinoType! !

CProgram subclass: #ArduinoSketch
	instanceVariableNames: ''
	classVariableNames: 'HIGH INPUT LOW OUTPUT'
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

ArduinoSketch class
	instanceVariableNames: 'instVarTypes'!

ArduinoSketch class
	instanceVariableNames: 'instVarTypes'!

ArduinoSketch subclass: #ArduinoBlinkSketch
	instanceVariableNames: 'ledPin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoBlinkSketch class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:48'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!ArduinoBlinkSketch class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:48'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLong)! !

!ArduinoBlinkSketch methodsFor: 'as yet unclassified' stamp: 'Richo 5/15/2012 14:22'!
loop
	self digitalWrite: ledPin value: HIGH;
		 delay: 100;
		 digitalWrite: ledPin value: LOW;
		 delay: 100! !

!ArduinoBlinkSketch methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2011 10:47'!
setup
	ledPin := 13.
	self pin: ledPin mode: OUTPUT! !

ArduinoSketch subclass: #ArduinoBlinkWithoutDelaySketch
	instanceVariableNames: 'ledPin ledState previousMillis interval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoBlinkWithoutDelaySketch class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:48'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!ArduinoBlinkWithoutDelaySketch class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:48'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLong #CLong #CLong #CLong)! !

!ArduinoBlinkWithoutDelaySketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
loop
	self millis - previousMillis > interval
	ifTrue: [
		previousMillis := self millis.
		ledState = LOW
		ifTrue: [
			ledState := HIGH
			]
		ifFalse: [
			ledState := LOW
			]
		].
	
	self digitalWrite: ledPin value: ledState! !

!ArduinoBlinkWithoutDelaySketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
setup
	ledPin := 13.
	ledState := LOW.
	previousMillis := 0.
	interval := 100.
	self  pin: ledPin mode: OUTPUT! !

ArduinoSketch subclass: #ArduinoButtonSketch
	instanceVariableNames: 'buttonPin ledPin buttonState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoButtonSketch class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:52'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!ArduinoButtonSketch class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:52'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLong #CLong #CLong)! !

!ArduinoButtonSketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
loop
buttonState := self digitalRead: buttonPin.
buttonState = HIGH
ifTrue: [
	self digitalWrite: ledPin value: HIGH
	]
ifFalse: [
	self digitalWrite: ledPin value: LOW
	]! !

!ArduinoButtonSketch methodsFor: 'as yet unclassified' stamp: 'Richo 5/15/2012 14:37'!
setup
ledPin := 14.
buttonPin := 15.
buttonState := 0.
self pin: ledPin mode: OUTPUT; pin: buttonPin mode: INPUT! !

ArduinoSketch subclass: #ArduinoDebounceSketch
	instanceVariableNames: 'buttonPin ledPin ledState buttonState lastButtonState lastDebounceTime debounceDelay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoDebounceSketch class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:52'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!ArduinoDebounceSketch class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:52'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLong #CLong #CLong #CLong #CLong #CLong #CLong)! !

!ArduinoDebounceSketch methodsFor: 'as yet unclassified' stamp: 'Richo 6/21/2011 16:23'!
loop
<tempTypes: #(CLong)>
| reading |
reading := self digitalRead: buttonPin.
reading ~= lastButtonState ifTrue: [lastDebounceTime := self millis].
(self millis - lastDebounceTime)  > debounceDelay ifTrue: [buttonState := reading].
self digitalWrite: ledPin value: buttonState.
lastButtonState := reading! !

!ArduinoDebounceSketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:16'!
setup
buttonPin := 9.
ledPin := 12.
ledState := HIGH.
lastButtonState := LOW.
lastDebounceTime := 0.
debounceDelay := 50.
self pin: buttonPin mode: INPUT; pin: ledPin mode: OUTPUT! !

ArduinoSketch subclass: #ArduinoDirectModeSketch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoDirectModeSketch class methodsFor: 'definition' stamp: 'Richo 10/23/2012 13:46'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #('"ArduinoDirectMode.h"')! !

!ArduinoDirectModeSketch class methodsFor: 'definition' stamp: 'Richo 10/23/2012 13:46'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!ArduinoDirectModeSketch methodsFor: 'as yet unclassified' stamp: 'Richo 5/15/2012 14:53'!
loop
	"Call the ArduinoDirectMode.h function"
	<c: 'loop()'>! !

!ArduinoDirectModeSketch methodsFor: 'as yet unclassified' stamp: 'Richo 5/15/2012 14:53'!
setup
	"Call the ArduinoDirectMode.h function"
	<c: 'setup()'>! !

!ArduinoSketch class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:50'!
allIncludes
	^ self includesUpTo: ArduinoSketch! !

!ArduinoSketch class methodsFor: 'definition' stamp: 'Richo 1/10/2012 15:36'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #('"CppFix.h"')! !

!ArduinoSketch class methodsFor: 'class initialization' stamp: 'Richo 6/21/2011 17:07'!
initialize
	"
	self initialize
	"
	HIGH := OUTPUT := 1.
	LOW := INPUT := 0! !

!ArduinoSketch class methodsFor: 'definition' stamp: 'Richo 1/10/2012 15:36'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!ArduinoSketch class methodsFor: 'testing' stamp: 'Richo 3/21/2012 19:40'!
testAllSubclasses
	"
	self testAllSubclasses
	"
	World findATranscript: nil. "Opens transcript"
	Transcript cr.
	self allSubclassesDo: [:each |
		Transcript show: each -> each translatedToArduinoC verify; cr]! !

!ArduinoSketch class methodsFor: 'translating' stamp: 'Richo 10/14/2011 16:32'!
translatedToArduinoC
	"Useful method to easily translate a program to c. By default the class name is used as program name"
	^ self translatedToArduinoC: #main! !

!ArduinoSketch class methodsFor: 'translating' stamp: 'Richo 10/14/2011 16:33'!
translatedToArduinoC: mainSelector 
	"Useful method to easily translate a program to c"
	^ self translatedToArduinoC: mainSelector named: self name! !

!ArduinoSketch class methodsFor: 'translating' stamp: 'Richo 10/14/2011 16:32'!
translatedToArduinoC: mainSelector named: programName 
	"Useful method to easily translate a program to c"
	^ ArduinoCProgramTranslator translate: mainSelector of: self asProgramNamed: programName! !

!ArduinoSketch methodsFor: 'functions-analog i/o' stamp: 'Richo 6/22/2011 16:43'!
analogRead: pinNumber
	<returnType: #(CLong)>
	<c: 'analogRead({1})'>! !

!ArduinoSketch methodsFor: 'functions-analog i/o' stamp: 'Richo 6/22/2011 16:52'!
analogWrite: pinNumber value: valueNumber
	<c: 'analogWrite({1},{2})'>! !

!ArduinoSketch methodsFor: 'functions-time' stamp: 'Richo 3/30/2012 17:50'!
currentTick
	<returnType: #(CUnsignedLong)>
	<c: 'millis()'>
	"
	Richo (30/03/2012): In order to simplify the player translators I'll
	use the same message used by Nxc
	"
	"Returns the number of milliseconds since the Arduino board began
	running the current program. This number will overflow (go back to
	zero), after approximately 50 days.
	
	Tip:
	
	Note that the parameter for millis is an unsigned long, errors may be
	generated if a programmer tries to do math with other datatypes
	such as ints.
	"
	^ self! !

!ArduinoSketch methodsFor: 'functions-time' stamp: 'Richo 6/21/2011 16:37'!
delay: milliseconds 
	<argTypes: #(CUnsignedLong)>
	<c: 'delay({1})'>
	"Pauses the program for the amount of time (in miliseconds) specified
	as parameter. (There are 1000 milliseconds in a second.)
	
	Caveat

While it is easy to create a blinking LED with the delay() function, and many sketches use short delays for such tasks as switch debouncing, the use of delay() in a sketch has significant drawbacks. No other reading of sensors, mathematical calculations, or pin manipulation can go on during the delay function, so in effect, it brings most other activity to a halt. For alternative approaches to controlling timing see the millis() function and the sketch sited below. More knowledgeable programmers usually avoid the use of delay() for timing of events longer than 10's of milliseconds unless the Arduino sketch is very simple.

Certain things do go on while the delay() function is controlling the Atmega chip however, because the delay function does not disable interrupts. Serial communication that appears at the RX pin is recorded, PWM (analogWrite) values and pin states are maintained, and interrupts will work as they should."
	^ self! !

!ArduinoSketch methodsFor: 'functions-time' stamp: 'Richo 6/21/2011 16:37'!
delayMicroseconds: microseconds
	<argTypes: #(CUnsignedLong)>
	<c: 'delayMicroseconds({1})'>
"Pauses the program for the amount of time (in microseconds) specified as parameter. There are a thousand microseconds in a millisecond, and a million microseconds in a second.

Currently, the largest value that will produce an accurate delay is 16383. This could change in future Arduino releases. For delays longer than a few thousand microseconds, you should use delay() instead.

Caveats and Known Issues

This function works very accurately in the range 3 microseconds and up. We cannot assure that delayMicroseconds will perform precisely for smaller delay-times."
^self! !

!ArduinoSketch methodsFor: 'functions-digital i/o' stamp: 'Richo 6/22/2011 16:22'!
digitalRead: pin
<returnType: #(CLong)>
<c: 'digitalRead({1})'>
"Reads the value from a specified digital pin, either HIGH or LOW."
^self! !

!ArduinoSketch methodsFor: 'functions-digital i/o' stamp: 'Richo 6/21/2011 16:40'!
digitalWrite: pinNumber value: pinValue 
	<argTypes: #(CLong CLong)>
	<c: 'digitalWrite({1}, {2})'>
	"Write a HIGH or a LOW value to a digital pin.
	
	If the pin has been configured as an OUTPUT with pinMode(), its
	voltage will be set to the corresponding value: 5V (or 3.3V on 3.3V
	boards) for HIGH, 0V (ground) for LOW.
	
	If the pin is configured as an INPUT, writing a HIGH value with
	digitalWrite() will enable an internal 20K pullup resistor (see the
	tutorial on digital pins). Writing LOW will disable the pullup. The pullup
	resistor is enough to light an LED dimly, so if LEDs appear to work,
	but very dimly, this is a likely cause. The remedy is to set the pin to
	an output with the pinMode() function.
	
	Note

The analog input pins can also be used as digital pins, referred to as numbers 14 (analog input 0) to 19 (analog input 5).
	"
	^ self! !

!ArduinoSketch methodsFor: 'program structure' stamp: 'Richo 6/21/2011 18:39'!
init
	<c: 'init()'>! !

!ArduinoSketch methodsFor: 'program structure' stamp: 'Richo 3/3/2010 17:38'!
loop
"After creating a setup() function, which initializes and sets the initial values, the loop() function does precisely what its name suggests, and loops consecutively, allowing your program to change and respond. Use it to actively control the Arduino board."
	self subclassResponsibility! !

!ArduinoSketch methodsFor: 'program structure' stamp: 'Richo 6/21/2011 19:04'!
main
	self init;
		setup.
	[self loop] repeat! !

!ArduinoSketch methodsFor: 'functions-time' stamp: 'Richo 6/22/2011 16:22'!
millis
	<returnType: #(CUnsignedLong)>
	<c: 'millis()'>
	"Returns the number of milliseconds since the Arduino board began
	running the current program. This number will overflow (go back to
	zero), after approximately 50 days.
	
	Tip:
	
	Note that the parameter for millis is an unsigned long, errors may be
	generated if a programmer tries to do math with other datatypes
	such as ints.
	"
	^ self! !

!ArduinoSketch methodsFor: 'functions-digital i/o' stamp: 'Richo 6/21/2011 16:40'!
pin: pinNumber mode: pinMode 
	<argTypes: #(CLong CLong)>
	<c: 'pinMode({1}, {2})'>
	"Configures the specified pin to behave either as an input or an
	output. See the description of digital pins for details.

	Note

The analog input pins can be used as digital pins, referred to as numbers 14 (analog input 0) to 19 (analog input 5).
	"
	^ self! !

!ArduinoSketch methodsFor: 'program structure' stamp: 'Richo 3/3/2010 17:38'!
setup
"The setup() function is called when a sketch starts. Use it to initialize variables, pin modes, start using libraries, etc. The setup function will only run once, after each powerup or reset of the Arduino board."
	self subclassResponsibility! !

ArduinoSketch subclass: #ArduinoTestSketch
	instanceVariableNames: 'led servo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoTestSketch class methodsFor: 'definition' stamp: 'Richo 2/22/2012 10:06'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!ArduinoTestSketch class methodsFor: 'definition' stamp: 'Richo 2/22/2012 10:06'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLong #CLong)! !

!ArduinoTestSketch methodsFor: 'as yet unclassified' stamp: 'Richo 6/29/2011 12:14'!
loop
"(self analogRead: 1) > 500
	ifTrue: [self digitalWrite: 12 value: 1]
	ifFalse: [self digitalWrite: 12 value: 0]."
	self analogWrite: 9 value: (self analogRead: 1).
	self turnOnLed: 1! !

!ArduinoTestSketch methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2011 16:44'!
setup
self pin: 12 mode: OUTPUT! !

!ArduinoTestSketch methodsFor: 'as yet unclassified' stamp: 'Richo 6/29/2011 12:14'!
turnOnLed: aNumber
	<argTypes: #(CLong)>
	self digitalWrite: led value: servo.
	servo = 1 ifTrue: [servo := 0] ifFalse: [servo := 1].
	self delay: aNumber! !

Error subclass: #CompilingSketchError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Uploading'!

Object subclass: #ArduinoCompiler
	instanceVariableNames: 'sketch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Uploading'!

!ArduinoCompiler commentStamp: 'Richo 10/26/2011 12:35' prior: 0!
I'm responsible for creating the necessary files to compile an already translated sketch. This files should be placed in the correct directory (see ArduinoUploader class comment for more info).!

!ArduinoCompiler class methodsFor: 'instance creation' stamp: 'Richo 10/25/2011 16:49'!
on: anArduinoTranslatedProgram
	^ self basicNew initializeWith: anArduinoTranslatedProgram! !

!ArduinoCompiler methodsFor: 'accessing' stamp: 'Richo 6/22/2011 09:54'!
allSketchesDirectory
	"It is important to keep this structure!!!!"
	^ (FileDirectory default directoryNamed: 'Arduino')
		directoryNamed: 'Sketches'! !

!ArduinoCompiler methodsFor: 'compiling' stamp: 'Richo 11/23/2012 12:56'!
compile
	^ self compileFor: self typeClass default! !

!ArduinoCompiler methodsFor: 'compiling' stamp: 'Richo 11/23/2012 12:16'!
compileFor: arduinoType
	self createMakefileFor: arduinoType;
		findLibrariesFromSketch;
		findLibrariesFromSource;
		createSourceFile! !

!ArduinoCompiler methodsFor: 'finding libraries' stamp: 'Richo 1/6/2012 20:09'!
copyLibraryFilesFrom: dir
	"All the files from the library directory must be copied to the sketch directory in order for the makefile to work. I know this could be done by tweaking the makefile but I don't like dealing with that stuff"
	dir fileNames do: [:fileName |
		dir fileNamed: fileName do: [:file1 |
			file1 binary.
			self sketchDirectory forceNewFileNamed: fileName do: [:file2 |
				file2 binary.
				self sketchDirectory copyFile: file1 toFile: file2]]]! !

!ArduinoCompiler methodsFor: 'compiling' stamp: 'Richo 11/23/2012 12:17'!
createMakefileFor: arduinoType
	self uploader
		createMakefileOn: self sketchDirectory
		for: arduinoType! !

!ArduinoCompiler methodsFor: 'initializing' stamp: 'Richo 6/22/2011 09:54'!
createSketchDirectory
	(self allSketchesDirectory directoryExists: sketch name)
		ifFalse: [self allSketchesDirectory createDirectory: sketch name].
	! !

!ArduinoCompiler methodsFor: 'compiling' stamp: 'Richo 6/22/2011 14:26'!
createSourceFile
	sketch saveInDirectory: self sketchDirectory! !

!ArduinoCompiler methodsFor: 'finding libraries' stamp: 'Richo 1/10/2012 13:53'!
findLibrariesFromSketch
	"Finds the libraries necessary to compile the sketch and copies them inside the sketch directory.
	It looks in the sketch includes"
	sketch allIncludes do: [:incl | 
		self copyLibraryFilesFrom: (self findLibrary: incl)]! !

!ArduinoCompiler methodsFor: 'finding libraries' stamp: 'Richo 1/6/2012 20:10'!
findLibrariesFromSource
	"Finds the libraries necessary to compile the sketch and copies them inside the sketch directory.
	It looks in the source files, and keeps looking until no file is added"
	| sourceFiles |
	[(sourceFiles := self sketchSourceFileNames)
		do: [:fileName |
			self sketchDirectory
				fileNamed: fileName
				do: [:file | self findLibrariesFromSource: file]]]
		doWhileTrue: [sourceFiles size ~= self sketchSourceFileNames size]
	! !

!ArduinoCompiler methodsFor: 'finding libraries' stamp: 'Richo 1/9/2012 16:14'!
findLibrariesFromSource: aFileStream
	"Parses the file contents looking for #include statements. It then tries to find and copy the results to the sketch directory. If the library is not found it does nothing because the include might be in the arduino core (which is handled correctly by the Makefile)"
	aFileStream contents
		regex: '#include[[:space:]]+["<][[:print:]]+[">]'
		matchesDo: [:match |
			match 
				regex: '["<][[:print:]]+[">]'
				matchesDo: [:include |
					[self copyLibraryFilesFrom: (self findLibrary: include)]
						on: Error do: ["Nothing"]]].



! !

!ArduinoCompiler methodsFor: 'finding libraries' stamp: 'Richo 12/29/2011 17:54'!
findLibrary: includeString
	"Look for the directory containing the library matching the name given as parameter and return it"
	^ self librariesDirectory
		directoryNamed: (self librariesDirectory directoryNames
				detect: [:dirName |
					(self librariesDirectory directoryNamed: dirName) fileNames 
						anySatisfy: [:fileName | '#' , fileName , '#' match: includeString]]
				ifNone: [self error: ('No library {1} was found' format: {includeString})]) ! !

!ArduinoCompiler methodsFor: 'initializing' stamp: 'Richo 10/25/2011 16:49'!
initializeWith: anArduinoSketch
	sketch := anArduinoSketch.
	self createSketchDirectory.
	self initialize! !

!ArduinoCompiler methodsFor: 'accessing' stamp: 'Richo 5/9/2012 15:19'!
librariesDirectory
	"It is important to keep this structure!!!!"
	^ ((FileDirectory default directoryNamed: 'Arduino')
		directoryNamed: 'hardware')
		directoryNamed: 'libraries'! !

!ArduinoCompiler methodsFor: 'accessing' stamp: 'Richo 6/22/2011 15:31'!
sketchDirectory
	^ self allSketchesDirectory directoryNamed: sketch name! !

!ArduinoCompiler methodsFor: 'accessing' stamp: 'Richo 1/6/2012 20:03'!
sketchSourceFileNames
	^ self sketchDirectory fileNames 
		select: [:fileName | 
			#('h' 'cpp' 'c' 'pde')
				anySatisfy: [:validExtension |
					fileName endsWith: '.', validExtension]]! !

!ArduinoCompiler methodsFor: 'accessing' stamp: 'Richo 11/23/2012 12:54'!
typeClass
	^ ArduinoType! !

!ArduinoCompiler methodsFor: 'uploading' stamp: 'Richo 11/23/2012 12:57'!
uploadOnPort: portName
	^ self uploadOnPort: portName arduinoType: self typeClass default! !

!ArduinoCompiler methodsFor: 'uploading' stamp: 'Richo 11/23/2012 12:14'!
uploadOnPort: portName arduinoType: arduinoType 
	self compileFor: arduinoType.
	^ self uploader
		uploadSketchNamed: sketch name
		onPort: portName
		arduinoType: arduinoType! !

!ArduinoCompiler methodsFor: 'accessing' stamp: 'Richo 5/9/2012 16:24'!
uploader
	^ ArduinoUploader forThisPlatform! !

!ArduinoCompiler methodsFor: 'verifying' stamp: 'Richo 11/23/2012 13:08'!
verify
	^ self verifyFor: self typeClass default! !

!ArduinoCompiler methodsFor: 'verifying' stamp: 'Richo 11/23/2012 12:22'!
verifyFor: arduinoType
	self compileFor: arduinoType.
	[^ self uploader
		compileSketchNamed: sketch name
		for: arduinoType]
		on: CompilingSketchError do: [:err | ^ err messageText]! !

Object subclass: #ArduinoUploader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Uploading'!

!ArduinoUploader commentStamp: 'Richo 10/26/2011 12:31' prior: 0!
I'm responsible for talking to avr in order to compile and upload sketches to the Arduino board.
My protocol is very simple: use #uploadSketchNamed:onPort:arduinoType: to upload your sketch and #compileSketchNamed: to simply compile it. Both methods should return a string specifying the sketch' size or signal a CompilingSketchError with error detail if the compilation failed for some reason.

To accomplish this task I need a specific directory tree:

.\Arduino
.\Arduino\hardware
.\Arduino\hardware\cores
.\Arduino\hardware\cores\arduino 
	"Contains the arduino source code (needed for compilation)"
.\Arduino\hardware\libraries
	"Contains all the needed libraries in separate folders"
.\Arduino\hardware\tools\
.\Arduino\hardware\tools\avr\
	"Contains the avr installation"
.\Arduino\Sketches
	"Contains the source code we are going to compile and upload"

Apart from that, I need a batch file called "upload.bat" in the sketches directory (.\Arduino\Sketches). This file is the responsible for calling make with the correct parameters, I simply execute it and hope for the best. 
Also, each sketch must have its own folder with a proper Makefile. The sketch folder must have the same name as the sketch. For instance, if I have a sketch named "Blink.pde" I must put it in ".\Arduino\Sketches\Blink". Otherwise, it won't compile.

!

ArduinoUploader subclass: #ArduinoMacUploader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Uploading'!

!ArduinoMacUploader class methodsFor: 'makefile' stamp: 'TS 4/10/2012 21:46'!
arduinoInstallDir
	"This must return the absolute path or the path relative to the image position to the sketch directory. Currently it expects Arduino.app alongside the squeak image"

	^FileDirectory default directoryNamed: 'Arduino.app/Contents/Resources/Java'! !

!ArduinoMacUploader class methodsFor: 'makefile' stamp: 'TS 4/9/2012 00:05'!
makefile
^'# Arduino 0015 Makefile
# Arduino adaptation by mellis, eighthave, oli.keller
#
# This makefile allows you to build sketches from the command line
# without the Arduino environment (or Java).
#
# Detailed instructions for using the makefile:
#
#  1. Copy this file into the folder with your sketch. There should be a
#     file with the same name as the folder and with the extension .pde
#     (e.g. foo.pde in the foo/ folder).
#
#  2. Modify the line containg "INSTALL_DIR" to point to the directory that
#     contains the Arduino installation (for example, under Mac OS X, this
#     might be /Applications/arduino-0012).
#
#  3. Modify the line containing "PORT" to refer to the filename
#     representing the USB or serial connection to your Arduino board
#     (e.g. PORT = /dev/tty.USB0).  If the exact name of this file
#     changes, you can use * as a wildcard (e.g. PORT = /dev/tty.usb*).
#
#  4. Set the line containing "MCU" to match your board''s processor. 
#     Older one''s are atmega8 based, newer ones like Arduino Mini, Bluetooth
#     or Diecimila have the atmega168.  If you''re using a LilyPad Arduino,
#     change F_CPU to 8000000.
#
#  5. At the command line, change to the directory containing your
#     program''s file and the makefile.
#
#  6. Type "make" and press enter to compile/verify your program.
#
#  7. Type "make upload", reset your Arduino board, and press enter to
#     upload your program to the Arduino board.
#
# $Id$

TARGET = Blink
INSTALL_DIR = $(ARDUINO_INSTALL_DIR)
PORT = com6
UPLOAD_RATE = 57600
AVRDUDE_PROGRAMMER = stk500
MCU = atmega328p
F_CPU = 16000000

############################################################################
# Below here nothing should be changed...

ARDUINO = $(INSTALL_DIR)/hardware/arduino/cores/arduino
AVR_TOOLS_PATH = $(INSTALL_DIR)/hardware/tools/avr/bin
SRC =  $(ARDUINO)/pins_arduino.c $(ARDUINO)/wiring.c \
$(ARDUINO)/wiring_analog.c $(ARDUINO)/wiring_digital.c \
$(ARDUINO)/wiring_pulse.c \
$(ARDUINO)/wiring_shift.c $(ARDUINO)/WInterrupts.c
CXXSRC = $(ARDUINO)/HardwareSerial.cpp $(ARDUINO)/WMath.cpp \
$(ARDUINO)/Print.cpp
FORMAT = ihex


# Name of this Makefile (used for "make depend").
MAKEFILE = Makefile

# Debugging format.
# Native formats for AVR-GCC''s -g are stabs [default], or dwarf-2.
# AVR (extended) COFF requires stabs, plus an avr-objcopy run.
DEBUG = stabs

OPT = s

# Place -D or -U options here
CDEFS = -DF_CPU=$(F_CPU)
CXXDEFS = -DF_CPU=$(F_CPU)

# Place -I options here
CINCS = -I$(ARDUINO)
CXXINCS = -I$(ARDUINO)

# Compiler flag to set the C Standard level.
# c89   - "ANSI" C
# gnu89 - c89 plus GCC extensions
# c99   - ISO C99 standard (not yet fully implemented)
# gnu99 - c99 plus GCC extensions
CSTANDARD = -std=gnu99
CDEBUG = -g$(DEBUG)
#CWARN = -Wall -Wstrict-prototypes
CWARN = -w
CTUNING = -funsigned-char -funsigned-bitfields -fpack-struct -fshort-enums
#CEXTRA = -Wa,-adhlns=$(<:.c=.lst)

CFLAGS = $(CDEBUG) $(CDEFS) $(CINCS) -O$(OPT) $(CWARN) $(CSTANDARD) $(CEXTRA)
CXXFLAGS = $(CDEFS) $(CINCS) -O$(OPT) $(CWARN)
#ASFLAGS = -Wa,-adhlns=$(<:.S=.lst),-gstabs 
LDFLAGS = -lm


# Programming support using avrdude. Settings and variables.
AVRDUDE_PORT = $(PORT)
AVRDUDE_WRITE_FLASH = -U flash:w:applet/$(TARGET).hex
AVRDUDE_FLAGS = -V -F -C $(INSTALL_DIR)/hardware/tools/avr/etc/avrdude.conf \
-p $(MCU) -P $(AVRDUDE_PORT) -c $(AVRDUDE_PROGRAMMER) \
-b $(UPLOAD_RATE)

# Program settings
CC = $(AVR_TOOLS_PATH)/avr-gcc
CXX = $(AVR_TOOLS_PATH)/avr-g++
OBJCOPY = $(AVR_TOOLS_PATH)/avr-objcopy
OBJDUMP = $(AVR_TOOLS_PATH)/avr-objdump
AR  = $(AVR_TOOLS_PATH)/avr-ar
SIZE = $(AVR_TOOLS_PATH)/avr-size
NM = $(AVR_TOOLS_PATH)/avr-nm
AVRDUDE = $(AVR_TOOLS_PATH)/avrdude
REMOVE = rm -f
MV = mv -f

# Define all object files.
OBJ = $(SRC:.c=.o) $(CXXSRC:.cpp=.o) $(ASRC:.S=.o) 

# Define all listing files.
LST = $(ASRC:.S=.lst) $(CXXSRC:.cpp=.lst) $(SRC:.c=.lst)

# Combine all necessary flags and optional flags.
# Add target processor to flags.
ALL_CFLAGS = -mmcu=$(MCU) -I. $(CFLAGS)
ALL_CXXFLAGS = -mmcu=$(MCU) -I. $(CXXFLAGS)
ALL_ASFLAGS = -mmcu=$(MCU) -I. -x assembler-with-cpp $(ASFLAGS)


# Default target.
all: applet_files build sizeafter

build: elf hex 

applet_files: $(TARGET).pde
	# Here is the "preprocessing".
	# It creates a .cpp file based with the same name as the .pde file.
	# On top of the new .cpp file comes the WProgram.h header.
	# At the end there is a generic main() function attached.
	# Then the .cpp file will be compiled. Errors during compile will
	# refer to this new, automatically generated, file. 
	# Not the original .pde file you actually edit...
	test -d applet || mkdir applet
	echo ''#include "WProgram.h"'' > applet/$(TARGET).cpp
	cat $(TARGET).pde >> applet/$(TARGET).cpp

elf: applet/$(TARGET).elf
hex: applet/$(TARGET).hex
eep: applet/$(TARGET).eep
lss: applet/$(TARGET).lss 
sym: applet/$(TARGET).sym

# Program the device.  
upload: applet/$(TARGET).hex
	$(AVRDUDE) $(AVRDUDE_FLAGS) $(AVRDUDE_WRITE_FLASH)


	# Display size of file.
HEXSIZE = $(SIZE) --target=$(FORMAT) applet/$(TARGET).hex
ELFSIZE = $(SIZE)  applet/$(TARGET).elf
sizebefore:
	@if [ -f applet/$(TARGET).elf ]; then echo; echo $(MSG_SIZE_BEFORE); $(HEXSIZE); echo; fi

sizeafter:
	@if [ -f applet/$(TARGET).elf ]; then echo; echo $(MSG_SIZE_AFTER); $(HEXSIZE); echo; fi


# Convert ELF to COFF for use in debugging / simulating in AVR Studio or VMLAB.
COFFCONVERT=$(OBJCOPY) --debugging \
--change-section-address .data-0x800000 \
--change-section-address .bss-0x800000 \
--change-section-address .noinit-0x800000 \
--change-section-address .eeprom-0x810000 


coff: applet/$(TARGET).elf
	$(COFFCONVERT) -O coff-avr applet/$(TARGET).elf $(TARGET).cof


extcoff: $(TARGET).elf
	$(COFFCONVERT) -O coff-ext-avr applet/$(TARGET).elf $(TARGET).cof


.SUFFIXES: .elf .hex .eep .lss .sym

.elf.hex:
	$(OBJCOPY) -O $(FORMAT) -R .eeprom $< $@

.elf.eep:
	-$(OBJCOPY) -j .eeprom --set-section-flags=.eeprom="alloc,load" \
	--change-section-lma .eeprom=0 -O $(FORMAT) $< $@

# Create extended listing file from ELF output file.
.elf.lss:
	$(OBJDUMP) -h -S $< > $@

# Create a symbol table from ELF output file.
.elf.sym:
	$(NM) -n $< > $@

	# Link: create ELF output file from library.
applet/$(TARGET).elf: $(TARGET).pde applet/core.a 
	$(CC) $(ALL_CFLAGS) -o $@ applet/$(TARGET).cpp -L. applet/core.a $(LDFLAGS)

applet/core.a: $(OBJ)
	@for i in $(OBJ); do echo $(AR) rcs applet/core.a $$i; $(AR) rcs applet/core.a $$i; done



# Compile: create object files from C++ source files.
%.o : %.cpp
	$(CXX) -c $(ALL_CXXFLAGS) $< -o $@ 

# Compile: create object files from C source files.
%.o : %.c
	$(CC) -c $(ALL_CFLAGS) $< -o $@ 


# Compile: create assembler files from C source files.
%.s : %.c
	$(CC) -S $(ALL_CFLAGS) $< -o $@


# Assemble: create object files from assembler source files.
%.o : %.S
	$(CC) -c $(ALL_ASFLAGS) $< -o $@


# Automatic dependencies
%.d: %.c
	$(CC) -M $(ALL_CFLAGS) $< | sed "s;$(notdir $*).o:;$*.o $*.d:;" > $@

%.d: %.cpp
	$(CXX) -M $(ALL_CXXFLAGS) $< | sed "s;$(notdir $*).o:;$*.o $*.d:;" > $@


# Target: clean project.
clean:
	$(REMOVE) applet/$(TARGET).hex applet/$(TARGET).eep applet/$(TARGET).cof applet/$(TARGET).elf \
	applet/$(TARGET).map applet/$(TARGET).sym applet/$(TARGET).lss applet/core.a \
	$(OBJ) $(LST) $(SRC:.c=.s) $(SRC:.c=.d) $(CXXSRC:.cpp=.s) $(CXXSRC:.cpp=.d)

.PHONY:	all build elf hex eep lss sym program coff extcoff clean applet_files sizebefore sizeafter

-include $(SRC:.c=.d)
-include $(CXXSRC:.cpp=.d)
'! !

!ArduinoMacUploader class methodsFor: 'instance creation' stamp: 'TS 3/31/2012 23:17'!
platformName
	^ 'Mac OS'! !

!ArduinoMacUploader methodsFor: 'as yet unclassified' stamp: 'TS 3/31/2012 23:36'!
changeCurrentDirectoryOf: osProcess to: pathString
	"Change current directory. We can't send #chDir: directly to osProcess
	because if it fails it shows an annoying error message to the user"
	| realPath result |
	realPath := osProcess processAccessor realpath: pathString.
	realPath ifNil: [realPath := pathString].
	result := osProcess processAccessor chDir: realPath.
	result isNil
		ifTrue:
			[(osProcess environmentAt: #PWD)
				ifNotNil:
					[osProcess environmentAt: #PWD put: realPath]]
		ifFalse: ["log message"].! !

!ArduinoMacUploader methodsFor: 'as yet unclassified' stamp: 'TS 4/10/2012 21:39'!
executeCompileFor: sketchName
	"Do not call this, use #compileSketchNamed:"
	| osProcess |
	osProcess := (Smalltalk
				at: #OSProcess
				ifAbsent: [^ self error: 'OSProcess not installed' translated]) thisOSProcess.
	self changeCurrentDirectoryOf: osProcess to: SmalltalkImage current imagePath , (self allSketchesDirectory).
	osProcess command: 'ARDUINO_INSTALL_DIR=',ArduinoMacUploader arduinoInstallDir fullName, ' ./upload.sh ' , sketchName.
	Transcript show: 'ARDUINO_INSTALL_DIR=',ArduinoMacUploader arduinoInstallDir fullName, ' ./upload.sh ' , sketchName; cr.
! !

!ArduinoMacUploader methodsFor: 'as yet unclassified' stamp: 'TS 4/10/2012 21:36'!
executeUploadFor: sketchName onPort: portName uploadRate: uploadRate mcu: mcu fCpu: fCpu avrdudeProgrammer: programmerId
	"Do not call this, use
	#uploadSketchNamed:onPort:arduinoType: "
	| osProcess |
		osProcess := (Smalltalk
				at: #OSProcess
				ifAbsent: [^ self error: 'OSProcess not installed' translated]) thisOSProcess.
	self changeCurrentDirectoryOf: osProcess to: SmalltalkImage current imagePath , (self allSketchesDirectory fullName).
	osProcess command: 'ARDUINO_INSTALL_DIR=',ArduinoMacUploader arduinoInstallDir fullName, ' ./upload.sh ' , sketchName , ' ' , portName , ' ' , uploadRate asString , ' ' , mcu , ' ' , fCpu asString , ' ' , programmerId.
	Transcript show: 'ARDUINO_INSTALL_DIR=',ArduinoMacUploader arduinoInstallDir fullName, ' ./upload.sh ' , sketchName , ' ' , portName , ' ' , uploadRate asString , ' ' , mcu , ' ' , fCpu asString , ' ' , programmerId; cr.
! !

ArduinoUploader subclass: #ArduinoUnixUploader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Uploading'!

!ArduinoUnixUploader class methodsFor: 'makefile' stamp: 'Richo 3/5/2012 18:34'!
makefile
^'# Arduino 0015 Makefile
# Arduino adaptation by mellis, eighthave, oli.keller
#
# This makefile allows you to build sketches from the command line
# without the Arduino environment (or Java).
#
# Detailed instructions for using the makefile:
#
#  1. Copy this file into the folder with your sketch. There should be a
#     file with the same name as the folder and with the extension .pde
#     (e.g. foo.pde in the foo/ folder).
#
#  2. Modify the line containg "INSTALL_DIR" to point to the directory that
#     contains the Arduino installation (for example, under Mac OS X, this
#     might be /Applications/arduino-0012).
#
#  3. Modify the line containing "PORT" to refer to the filename
#     representing the USB or serial connection to your Arduino board
#     (e.g. PORT = /dev/tty.USB0).  If the exact name of this file
#     changes, you can use * as a wildcard (e.g. PORT = /dev/tty.usb*).
#
#  4. Set the line containing "MCU" to match your board''s processor. 
#     Older one''s are atmega8 based, newer ones like Arduino Mini, Bluetooth
#     or Diecimila have the atmega168.  If you''re using a LilyPad Arduino,
#     change F_CPU to 8000000.
#
#  5. At the command line, change to the directory containing your
#     program''s file and the makefile.
#
#  6. Type "make" and press enter to compile/verify your program.
#
#  7. Type "make upload", reset your Arduino board, and press enter to
#     upload your program to the Arduino board.
#
# $Id$

TARGET = Blink
INSTALL_DIR = ../..
PORT = com6
UPLOAD_RATE = 57600
AVRDUDE_PROGRAMMER = stk500
MCU = atmega328p
F_CPU = 16000000

############################################################################
# Below here nothing should be changed...

ARDUINO = $(INSTALL_DIR)/hardware/cores/arduino
AVR_TOOLS_PATH = $(INSTALL_DIR)/hardware/tools/avr/bin
SRC =  $(ARDUINO)/pins_arduino.c $(ARDUINO)/wiring.c \
$(ARDUINO)/wiring_analog.c $(ARDUINO)/wiring_digital.c \
$(ARDUINO)/wiring_pulse.c \
$(ARDUINO)/wiring_shift.c $(ARDUINO)/WInterrupts.c
CXXSRC = $(ARDUINO)/HardwareSerial.cpp $(ARDUINO)/WMath.cpp \
$(ARDUINO)/Print.cpp
FORMAT = ihex


# Name of this Makefile (used for "make depend").
MAKEFILE = Makefile

# Debugging format.
# Native formats for AVR-GCC''s -g are stabs [default], or dwarf-2.
# AVR (extended) COFF requires stabs, plus an avr-objcopy run.
DEBUG = stabs

OPT = s

# Place -D or -U options here
CDEFS = -DF_CPU=$(F_CPU)
CXXDEFS = -DF_CPU=$(F_CPU)

# Place -I options here
CINCS = -I$(ARDUINO)
CXXINCS = -I$(ARDUINO)

# Compiler flag to set the C Standard level.
# c89   - "ANSI" C
# gnu89 - c89 plus GCC extensions
# c99   - ISO C99 standard (not yet fully implemented)
# gnu99 - c99 plus GCC extensions
CSTANDARD = -std=gnu99
CDEBUG = -g$(DEBUG)
#CWARN = -Wall -Wstrict-prototypes
CWARN = -w
CTUNING = -funsigned-char -funsigned-bitfields -fpack-struct -fshort-enums
#CEXTRA = -Wa,-adhlns=$(<:.c=.lst)

CFLAGS = $(CDEBUG) $(CDEFS) $(CINCS) -O$(OPT) $(CWARN) $(CSTANDARD) $(CEXTRA)
CXXFLAGS = $(CDEFS) $(CINCS) -O$(OPT) $(CWARN)
#ASFLAGS = -Wa,-adhlns=$(<:.S=.lst),-gstabs 
LDFLAGS = -lm


# Programming support using avrdude. Settings and variables.
AVRDUDE_PORT = $(PORT)
AVRDUDE_WRITE_FLASH = -U flash:w:applet/$(TARGET).hex
AVRDUDE_FLAGS = -V -F -C $(INSTALL_DIR)/hardware/tools/avr/etc/avrdude.conf \
-p $(MCU) -P $(AVRDUDE_PORT) -c $(AVRDUDE_PROGRAMMER) \
-b $(UPLOAD_RATE)

# Program settings
CC = avr-gcc
CXX = avr-g++
OBJCOPY = avr-objcopy
OBJDUMP = avr-objdump
AR  = avr-ar
SIZE = avr-size
NM = avr-nm
AVRDUDE = $(AVR_TOOLS_PATH)/avrdude
REMOVE = rm -f
MV = mv -f

# Define all object files.
OBJ = $(SRC:.c=.o) $(CXXSRC:.cpp=.o) $(ASRC:.S=.o) 

# Define all listing files.
LST = $(ASRC:.S=.lst) $(CXXSRC:.cpp=.lst) $(SRC:.c=.lst)

# Combine all necessary flags and optional flags.
# Add target processor to flags.
ALL_CFLAGS = -mmcu=$(MCU) -I. $(CFLAGS)
ALL_CXXFLAGS = -mmcu=$(MCU) -I. $(CXXFLAGS)
ALL_ASFLAGS = -mmcu=$(MCU) -I. -x assembler-with-cpp $(ASFLAGS)


# Default target.
all: applet_files build sizeafter

build: elf hex 

applet_files: $(TARGET).pde
	# Here is the "preprocessing".
	# It creates a .cpp file based with the same name as the .pde file.
	# On top of the new .cpp file comes the WProgram.h header.
	# At the end there is a generic main() function attached.
	# Then the .cpp file will be compiled. Errors during compile will
	# refer to this new, automatically generated, file. 
	# Not the original .pde file you actually edit...
	test -d applet || mkdir applet
	echo ''#include "WProgram.h"'' > applet/$(TARGET).cpp
	cat $(TARGET).pde >> applet/$(TARGET).cpp

elf: applet/$(TARGET).elf
hex: applet/$(TARGET).hex
eep: applet/$(TARGET).eep
lss: applet/$(TARGET).lss 
sym: applet/$(TARGET).sym

# Program the device.  
upload: applet/$(TARGET).hex
	$(AVRDUDE) $(AVRDUDE_FLAGS) $(AVRDUDE_WRITE_FLASH)


	# Display size of file.
HEXSIZE = $(SIZE) --target=$(FORMAT) applet/$(TARGET).hex
ELFSIZE = $(SIZE)  applet/$(TARGET).elf
sizebefore:
	@if [ -f applet/$(TARGET).elf ]; then echo; echo $(MSG_SIZE_BEFORE); $(HEXSIZE); echo; fi

sizeafter:
	@if [ -f applet/$(TARGET).elf ]; then echo; echo $(MSG_SIZE_AFTER); $(HEXSIZE); echo; fi


# Convert ELF to COFF for use in debugging / simulating in AVR Studio or VMLAB.
COFFCONVERT=$(OBJCOPY) --debugging \
--change-section-address .data-0x800000 \
--change-section-address .bss-0x800000 \
--change-section-address .noinit-0x800000 \
--change-section-address .eeprom-0x810000 


coff: applet/$(TARGET).elf
	$(COFFCONVERT) -O coff-avr applet/$(TARGET).elf $(TARGET).cof


extcoff: $(TARGET).elf
	$(COFFCONVERT) -O coff-ext-avr applet/$(TARGET).elf $(TARGET).cof


.SUFFIXES: .elf .hex .eep .lss .sym

.elf.hex:
	$(OBJCOPY) -O $(FORMAT) -R .eeprom $< $@

.elf.eep:
	-$(OBJCOPY) -j .eeprom --set-section-flags=.eeprom="alloc,load" \
	--change-section-lma .eeprom=0 -O $(FORMAT) $< $@

# Create extended listing file from ELF output file.
.elf.lss:
	$(OBJDUMP) -h -S $< > $@

# Create a symbol table from ELF output file.
.elf.sym:
	$(NM) -n $< > $@

	# Link: create ELF output file from library.
applet/$(TARGET).elf: $(TARGET).pde applet/core.a 
	$(CC) $(ALL_CFLAGS) -o $@ applet/$(TARGET).cpp -L. applet/core.a $(LDFLAGS)

applet/core.a: $(OBJ)
	@for i in $(OBJ); do echo $(AR) rcs applet/core.a $$i; $(AR) rcs applet/core.a $$i; done



# Compile: create object files from C++ source files.
.cpp.o:
	$(CXX) -c $(ALL_CXXFLAGS) $< -o $@ 

# Compile: create object files from C source files.
.c.o:
	$(CC) -c $(ALL_CFLAGS) $< -o $@ 


# Compile: create assembler files from C source files.
.c.s:
	$(CC) -S $(ALL_CFLAGS) $< -o $@


# Assemble: create object files from assembler source files.
.S.o:
	$(CC) -c $(ALL_ASFLAGS) $< -o $@


# Automatic dependencies
%.d: %.c
	$(CC) -M $(ALL_CFLAGS) $< | sed "s;$(notdir $*).o:;$*.o $*.d:;" > $@

%.d: %.cpp
	$(CXX) -M $(ALL_CXXFLAGS) $< | sed "s;$(notdir $*).o:;$*.o $*.d:;" > $@


# Target: clean project.
clean:
	$(REMOVE) applet/$(TARGET).hex applet/$(TARGET).eep applet/$(TARGET).cof applet/$(TARGET).elf \
	applet/$(TARGET).map applet/$(TARGET).sym applet/$(TARGET).lss applet/core.a \
	$(OBJ) $(LST) $(SRC:.c=.s) $(SRC:.c=.d) $(CXXSRC:.cpp=.s) $(CXXSRC:.cpp=.d)

.PHONY:	all build elf hex eep lss sym program coff extcoff clean applet_files sizebefore sizeafter

-include $(SRC:.c=.d)
-include $(CXXSRC:.cpp=.d)
'! !

!ArduinoUnixUploader class methodsFor: 'instance creation' stamp: 'TS 3/31/2012 23:16'!
platformName
	^ 'unix'! !

!ArduinoUnixUploader methodsFor: 'as yet unclassified' stamp: 'TS 3/30/2012 23:48'!
changeCurrentDirectoryOf: osProcess to: pathString
	"Change current directory. We can't send #chDir: directly to osProcess
	because if it fails it shows an annoying error message to the user"
	| realPath result |
	realPath := osProcess processAccessor realpath: pathString.
	realPath ifNil: [realPath := pathString].
	result := osProcess processAccessor chDir: realPath.
	result isNil
		ifTrue:
			[(osProcess environmentAt: #PWD)
				ifNotNil:
					[osProcess environmentAt: #PWD put: realPath]]
		ifFalse: ["log message"].! !

!ArduinoUnixUploader methodsFor: 'as yet unclassified' stamp: 'Richo 3/16/2012 18:13'!
executeCompileFor: sketchName 
	"Do not call this, use #compileSketch:"
	| osProcess |
	osProcess := (Smalltalk
				at: #OSProcess
				ifAbsent: [^ self error: 'OSProcess not installed' translated]) thisOSProcess.
	self changeCurrentDirectoryOf: osProcess to: SmalltalkImage current imagePath , '/Arduino/Sketches'.
	osProcess command: './upload.sh ' , sketchName ! !

!ArduinoUnixUploader methodsFor: 'as yet unclassified' stamp: 'Richo 3/16/2012 18:14'!
executeUploadFor: sketchName onPort: portName uploadRate: uploadRate mcu: mcu fCpu: fCpu avrdudeProgrammer: programmerId 
	"Do not call this, use
	#uploadSketchNamed:onPort:arduinoType:"
	| osProcess |
	osProcess := (Smalltalk
				at: #OSProcess
				ifAbsent: [^ self error: 'OSProcess not installed' translated]) thisOSProcess.
	self changeCurrentDirectoryOf: osProcess to: SmalltalkImage current imagePath , '/Arduino/Sketches'.
	osProcess command: './upload.sh ' , sketchName , ' ' , portName , ' ' , uploadRate asString , ' ' , mcu , ' ' , fCpu asString , ' ' , programmerId! !

!ArduinoUploader class methodsFor: 'instance creation' stamp: 'Richo 5/15/2012 13:09'!
forThisPlatform
	(self subclasses 
		detect: [:each | each platformName = SmalltalkImage current platformName]
		ifNone: [nil])
			ifNil: [^ self error: SmalltalkImage current platformName, 
								' - Platform not supported' translated]
			ifNotNil: [:actualClass |
				^ actualClass basicNew initialize]! !

!ArduinoUploader class methodsFor: 'makefile' stamp: 'Richo 11/23/2012 12:26'!
makefile
	self flag: #Richo. "This file should be cross-platform"
	^ self subclassResponsibility! !

!ArduinoUploader class methodsFor: 'makefile' stamp: 'Richo 11/23/2012 12:18'!
makefileFor: arduinoType
	"Arduino has a single makefile"
	^ self makefile! !

!ArduinoUploader class methodsFor: 'instance creation' stamp: 'Richo 3/5/2012 18:37'!
new
	^ self forThisPlatform! !

!ArduinoUploader class methodsFor: 'instance creation' stamp: 'Richo 3/5/2012 18:46'!
platformName
	"Subclasses should return the name of their platform"
	^ self subclassResponsibility ! !

!ArduinoUploader methodsFor: 'accessing' stamp: 'Richo 6/22/2011 10:31'!
allSketchesDirectory
	"It is important to keep this structure!!!!"
	^ (FileDirectory default directoryNamed: 'Arduino')
		directoryNamed: 'Sketches'! !

!ArduinoUploader methodsFor: 'private' stamp: 'Richo 10/26/2011 12:09'!
checkForErrorsOn: errorsFile
	errorsFile contents
		ifNotEmpty: [:contents | ^CompilingSketchError signal: contents]
	! !

!ArduinoUploader methodsFor: 'public' stamp: 'Richo 11/23/2012 13:12'!
compileSketchNamed: sketchName for: arduinoType
	| sketchDirectory |
	sketchDirectory := self allSketchesDirectory directoryNamed: sketchName.
	(sketchDirectory	fileExists: 'Makefile')
		ifFalse: [self createMakefileOn: sketchDirectory for: arduinoType].
	self
		waitFor: self timeoutSeconds
		untilFinish: [self executeCompileFor: sketchName]
		on: sketchDirectory.
	sketchDirectory
		fileNamed: 'err'
		do: [:errors | self checkForErrorsOn: errors];
		fileNamed: 'out'
		do: [:out | ^ out contents]! !

!ArduinoUploader methodsFor: 'makefile creation' stamp: 'Richo 11/23/2012 12:19'!
createMakefileOn: directory for: arduinoType
	"The Makefile *must* have lf as line ending"
	| makefile |
	makefile := self class makefileFor: arduinoType.
	directory forceNewFileNamed: 'Makefile' do: [:file |
		file nextPutAll: (makefile copyReplaceAll: String cr with: String lf)]! !

!ArduinoUploader methodsFor: 'private' stamp: 'Richo 3/5/2012 18:31'!
executeCompileFor: sketchName
	"Do not call this, use #compileSketchNamed:"
	self subclassResponsibility! !

!ArduinoUploader methodsFor: 'private' stamp: 'Richo 3/5/2012 18:32'!
executeUploadFor: sketchName onPort: portName uploadRate: uploadRate mcu: mcu fCpu: fCpu avrdudeProgrammer: programmerId 
	"Do not call this, use #uploadSketchNamed:onPort:arduinoType:"
	self subclassResponsibility! !

!ArduinoUploader methodsFor: 'accessing' stamp: 'Richo 1/5/2010 12:45'!
timeoutSeconds
^45! !

!ArduinoUploader methodsFor: 'public' stamp: 'Richo 11/23/2012 12:25'!
uploadSketchNamed: sketchName onPort: portName arduinoType: arduinoType
	| sketchDirectory |
	sketchDirectory := self allSketchesDirectory directoryNamed: sketchName.
	(sketchDirectory fileExists: 'Makefile')
		ifFalse: [self createMakefileOn: sketchDirectory for: arduinoType].
	self
		waitFor: self timeoutSeconds
		untilFinish: [self
				executeUploadFor: sketchName
				onPort: portName
				uploadRate: arduinoType uploadRate
				mcu: arduinoType mcu
				fCpu: arduinoType fCpu
				avrdudeProgrammer: arduinoType avrdudeProgrammer]
		on: sketchDirectory.
	sketchDirectory
		fileNamed: 'err'
		do: [:errors | self checkForErrorsOn: errors];
		fileNamed: 'out'
		do: [:out | ^ out contents]! !

!ArduinoUploader methodsFor: 'private' stamp: 'Richo 3/3/2012 02:09'!
waitFor: timeoutSeconds untilFinish: aBlock on: sketchDirectory 
	"To make sure the process finishes correctly I wait until the sketch directory contains a file named 'finish', which should be created after evaluating the block"
	| delay timeout |
	timeout := timeoutSeconds.
	sketchDirectory
		deleteFileNamed: 'finish' ifAbsent: [].
	aBlock value.
	delay := Delay forSeconds: 1.
	[delay wait.
	timeout := timeout - 1]
		doWhileFalse: [timeout = 0
				or: [sketchDirectory fileExists: 'finish']].
	timeout = 0
		ifTrue: [self error: 'Timeout. The process failed for unknown reasons. Please try again later' translated]! !

ArduinoUploader subclass: #ArduinoWin32Uploader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Uploading'!

!ArduinoWin32Uploader class methodsFor: 'makefile' stamp: 'Richo 5/16/2012 17:29'!
makefile
^'# Arduino 0015 Makefile
# Arduino adaptation by mellis, eighthave, oli.keller
#
# This makefile allows you to build sketches from the command line
# without the Arduino environment (or Java).
#
# Detailed instructions for using the makefile:
#
#  1. Copy this file into the folder with your sketch. There should be a
#     file with the same name as the folder and with the extension .pde
#     (e.g. foo.pde in the foo/ folder).
#
#  2. Modify the line containg "INSTALL_DIR" to point to the directory that
#     contains the Arduino installation (for example, under Mac OS X, this
#     might be /Applications/arduino-0012).
#
#  3. Modify the line containing "PORT" to refer to the filename
#     representing the USB or serial connection to your Arduino board
#     (e.g. PORT = /dev/tty.USB0).  If the exact name of this file
#     changes, you can use * as a wildcard (e.g. PORT = /dev/tty.usb*).
#
#  4. Set the line containing "MCU" to match your board''s processor. 
#     Older one''s are atmega8 based, newer ones like Arduino Mini, Bluetooth
#     or Diecimila have the atmega168.  If you''re using a LilyPad Arduino,
#     change F_CPU to 8000000.
#
#  5. At the command line, change to the directory containing your
#     program''s file and the makefile.
#
#  6. Type "make" and press enter to compile/verify your program.
#
#  7. Type "make upload", reset your Arduino board, and press enter to
#     upload your program to the Arduino board.
#
# $Id$

TARGET = Blink
INSTALL_DIR = ../..
PORT = com6
UPLOAD_RATE = 57600
AVRDUDE_PROGRAMMER = stk500
MCU = atmega328p
F_CPU = 16000000

############################################################################
# Below here nothing should be changed...

ARDUINO = $(INSTALL_DIR)/hardware/arduino/cores/arduino
AVR_TOOLS_PATH = $(INSTALL_DIR)/hardware/tools/avr/bin
SRC =  $(ARDUINO)/pins_arduino.c $(ARDUINO)/wiring.c \
$(ARDUINO)/wiring_analog.c $(ARDUINO)/wiring_digital.c \
$(ARDUINO)/wiring_pulse.c \
$(ARDUINO)/wiring_shift.c $(ARDUINO)/WInterrupts.c $(ARDUINO)/WString.c
CXXSRC = $(ARDUINO)/HardwareSerial.cpp $(ARDUINO)/WMath.cpp \
$(ARDUINO)/Print.cpp
FORMAT = ihex


# Name of this Makefile (used for "make depend").
MAKEFILE = Makefile

# Debugging format.
# Native formats for AVR-GCC''s -g are stabs [default], or dwarf-2.
# AVR (extended) COFF requires stabs, plus an avr-objcopy run.
DEBUG = stabs

OPT = s

# Place -D or -U options here
CDEFS = -DF_CPU=$(F_CPU)
CXXDEFS = -DF_CPU=$(F_CPU)

# Place -I options here
CINCS = -I$(ARDUINO)
CXXINCS = -I$(ARDUINO)

# Compiler flag to set the C Standard level.
# c89   - "ANSI" C
# gnu89 - c89 plus GCC extensions
# c99   - ISO C99 standard (not yet fully implemented)
# gnu99 - c99 plus GCC extensions
CSTANDARD = -std=gnu99
CDEBUG = -g$(DEBUG)
#CWARN = -Wall -Wstrict-prototypes
CWARN = -w
CTUNING = -funsigned-char -funsigned-bitfields -fpack-struct -fshort-enums
#CEXTRA = -Wa,-adhlns=$(<:.c=.lst)

CFLAGS = $(CDEBUG) $(CDEFS) $(CINCS) -O$(OPT) $(CWARN) $(CSTANDARD) $(CEXTRA)
CXXFLAGS = $(CDEFS) $(CINCS) -O$(OPT) $(CWARN)
#ASFLAGS = -Wa,-adhlns=$(<:.S=.lst),-gstabs 
LDFLAGS = -lm


# Programming support using avrdude. Settings and variables.
AVRDUDE_PORT = $(PORT)
AVRDUDE_WRITE_FLASH = -U flash:w:applet/$(TARGET).hex
AVRDUDE_FLAGS = -V -F -C $(INSTALL_DIR)/hardware/tools/avr/etc/avrdude.conf \
-p $(MCU) -P $(AVRDUDE_PORT) -c $(AVRDUDE_PROGRAMMER) \
-b $(UPLOAD_RATE)

# Program settings
CC = $(AVR_TOOLS_PATH)/avr-gcc
CXX = $(AVR_TOOLS_PATH)/avr-g++
OBJCOPY = $(AVR_TOOLS_PATH)/avr-objcopy
OBJDUMP = $(AVR_TOOLS_PATH)/avr-objdump
AR  = $(AVR_TOOLS_PATH)/avr-ar
SIZE = $(AVR_TOOLS_PATH)/avr-size
NM = $(AVR_TOOLS_PATH)/avr-nm
AVRDUDE = $(AVR_TOOLS_PATH)/avrdude_orig
REMOVE = rm -f
MV = mv -f

# Define all object files.
OBJ = $(SRC:.c=.o) $(CXXSRC:.cpp=.o) $(ASRC:.S=.o) 

# Define all listing files.
LST = $(ASRC:.S=.lst) $(CXXSRC:.cpp=.lst) $(SRC:.c=.lst)

# Combine all necessary flags and optional flags.
# Add target processor to flags.
ALL_CFLAGS = -mmcu=$(MCU) -I. $(CFLAGS)
ALL_CXXFLAGS = -mmcu=$(MCU) -I. $(CXXFLAGS)
ALL_ASFLAGS = -mmcu=$(MCU) -I. -x assembler-with-cpp $(ASFLAGS)


# Default target.
all: applet_files build sizeafter

build: elf hex 

applet_files: $(TARGET).pde
	# Here is the "preprocessing".
	# It creates a .cpp file based with the same name as the .pde file.
	# On top of the new .cpp file comes the WProgram.h header.
	# At the end there is a generic main() function attached.
	# Then the .cpp file will be compiled. Errors during compile will
	# refer to this new, automatically generated, file. 
	# Not the original .pde file you actually edit...
	test -d applet || mkdir applet
	echo ''#include "WProgram.h"'' > applet/$(TARGET).cpp
	cat $(TARGET).pde >> applet/$(TARGET).cpp

elf: applet/$(TARGET).elf
hex: applet/$(TARGET).hex
eep: applet/$(TARGET).eep
lss: applet/$(TARGET).lss 
sym: applet/$(TARGET).sym

# Program the device.  
upload: applet/$(TARGET).hex
	$(AVRDUDE) $(AVRDUDE_FLAGS) $(AVRDUDE_WRITE_FLASH)


	# Display size of file.
HEXSIZE = $(SIZE) --target=$(FORMAT) applet/$(TARGET).hex
ELFSIZE = $(SIZE)  applet/$(TARGET).elf
sizebefore:
	@if [ -f applet/$(TARGET).elf ]; then echo; echo $(MSG_SIZE_BEFORE); $(HEXSIZE); echo; fi

sizeafter:
	@if [ -f applet/$(TARGET).elf ]; then echo; echo $(MSG_SIZE_AFTER); $(HEXSIZE); echo; fi


# Convert ELF to COFF for use in debugging / simulating in AVR Studio or VMLAB.
COFFCONVERT=$(OBJCOPY) --debugging \
--change-section-address .data-0x800000 \
--change-section-address .bss-0x800000 \
--change-section-address .noinit-0x800000 \
--change-section-address .eeprom-0x810000 


coff: applet/$(TARGET).elf
	$(COFFCONVERT) -O coff-avr applet/$(TARGET).elf $(TARGET).cof


extcoff: $(TARGET).elf
	$(COFFCONVERT) -O coff-ext-avr applet/$(TARGET).elf $(TARGET).cof


.SUFFIXES: .elf .hex .eep .lss .sym

.elf.hex:
	$(OBJCOPY) -O $(FORMAT) -R .eeprom $< $@

.elf.eep:
	-$(OBJCOPY) -j .eeprom --set-section-flags=.eeprom="alloc,load" \
	--change-section-lma .eeprom=0 -O $(FORMAT) $< $@

# Create extended listing file from ELF output file.
.elf.lss:
	$(OBJDUMP) -h -S $< > $@

# Create a symbol table from ELF output file.
.elf.sym:
	$(NM) -n $< > $@

	# Link: create ELF output file from library.
applet/$(TARGET).elf: $(TARGET).pde applet/core.a 
	$(CC) $(ALL_CFLAGS) -o $@ applet/$(TARGET).cpp -L. applet/core.a $(LDFLAGS)

applet/core.a: $(OBJ)
	@for i in $(OBJ); do echo $(AR) rcs applet/core.a $$i; $(AR) rcs applet/core.a $$i; done



# Compile: create object files from C++ source files.
.cpp.o:
	$(CXX) -c $(ALL_CXXFLAGS) $< -o $@ 

# Compile: create object files from C source files.
.c.o:
	$(CC) -c $(ALL_CFLAGS) $< -o $@ 


# Compile: create assembler files from C source files.
.c.s:
	$(CC) -S $(ALL_CFLAGS) $< -o $@


# Assemble: create object files from assembler source files.
.S.o:
	$(CC) -c $(ALL_ASFLAGS) $< -o $@


# Automatic dependencies
%.d: %.c
	$(CC) -M $(ALL_CFLAGS) $< | sed "s;$(notdir $*).o:;$*.o $*.d:;" > $@

%.d: %.cpp
	$(CXX) -M $(ALL_CXXFLAGS) $< | sed "s;$(notdir $*).o:;$*.o $*.d:;" > $@


# Target: clean project.
clean:
	$(REMOVE) applet/$(TARGET).hex applet/$(TARGET).eep applet/$(TARGET).cof applet/$(TARGET).elf \
	applet/$(TARGET).map applet/$(TARGET).sym applet/$(TARGET).lss applet/core.a \
	$(OBJ) $(LST) $(SRC:.c=.s) $(SRC:.c=.d) $(CXXSRC:.cpp=.s) $(CXXSRC:.cpp=.d)

.PHONY:	all build elf hex eep lss sym program coff extcoff clean applet_files sizebefore sizeafter

-include $(SRC:.c=.d)
-include $(CXXSRC:.cpp=.d)
'! !

!ArduinoWin32Uploader class methodsFor: 'instance creation' stamp: 'Richo 3/5/2012 18:47'!
platformName
	^ 'Win32'! !

!ArduinoWin32Uploader methodsFor: 'as yet unclassified' stamp: 'Richo 3/5/2012 18:29'!
executeCompileFor: sketchName
	"Do not call this, use #compileSketch:"
	((Smalltalk
			at: #Win32Shell
			ifAbsent: [^ self error: 'FFI not installed' translated]) new
			shellExecute: nil
			lpOperation: 'open'
			lpFile: 'upload.bat'
			lpParameters: sketchName
			lpDirectory: 'Arduino\Sketches'
			nShowCmd: 1)
			<= 32
		ifTrue: [self error: 'System error' translated]! !

!ArduinoWin32Uploader methodsFor: 'as yet unclassified' stamp: 'Richo 12/6/2012 01:12'!
executeUploadFor: sketchName onPort: portName uploadRate: uploadRate mcu: mcu fCpu: fCpu avrdudeProgrammer: programmerId
	"Do not call this, use #uploadSketchNamed:onPort:arduinoType:"
	((Smalltalk
			at: #Win32Shell
			ifAbsent: [^ self error: 'FFI not installed' translated]) new
			shellExecute: nil
			lpOperation: 'open'
			lpFile: 'upload.bat'
			lpParameters: sketchName , ' ' , portName , ' ' , uploadRate asString , ' ' , mcu , ' ' , fCpu asString , ' ' , programmerId
			lpDirectory: 'Arduino\Sketches'
			nShowCmd: 6)
			<= 32
		ifTrue: [self error: 'System error' translated]! !

CppProgramTranslator subclass: #ArduinoCProgramTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Translators'!

!ArduinoCProgramTranslator class methodsFor: 'output builder' stamp: 'Richo 10/14/2011 16:30'!
kit
	^ ArduinoCKit! !
ArduinoSketch initialize!
